package oclib

type Datacenter struct {
	AbstractResource `json:"resource" required:"true"`

	Owner        string `json:"owner" required:"true"`
	BookingPrice int    `json:"booking_price" required:"true"`

	CPU DatacenterCpuModel    `json:"cpu,omitempty"`
	RAM DatacenterMemoryModel `json:"ram,omitempty"`
	GPU []DatacenterGpuModel  `json:"gpu,omitempty"`
}

type DatacenterCpuModel struct {
	Cores         uint   `json:"cores,omitempty"`        //TODO: validate
	Architecture  string `json:"architecture,omitempty"` //TOOD: enum
	Shared        bool   `json:"shared,omitempty"`
	MinimumMemory uint   `json:"minimum_memory,omitempty"`
	Platform      string `json:"platform,omitempty"`
}

type DatacenterMemoryModel struct {
	Size uint `json:"size,omitempty" description:"Units in MB"`
	Ecc  bool `json:"ecc,omitempty"`
}

type DatacenterGpuModel struct {
	CudaCores   uint   `json:"cuda_cores,omitempty"`
	Model       string `json:"model,omitempty"`
	Memory      uint   `json:"memory,omitempty" description:"Units in MB"`
	TensorCores uint   `json:"tensor_cores,omitempty"`
}


func (d *Datacenter) GetType() ResourceType{
	return DATACENTER
}